"""
    UniCourt Enterprise APIs

    <button><a href=\"/enterpriseapi/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button>   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from unicourt.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from unicourt.exceptions import ApiAttributeError


def lazy_import():
    from unicourt.model.attorney_law_firm import AttorneyLawFirm
    from unicourt.model.attorney_type import AttorneyType
    from unicourt.model.contact import Contact
    from unicourt.model.party_attorney_associations import PartyAttorneyAssociations
    from unicourt.model.possible_norm_attorney import PossibleNormAttorney
    from unicourt.model.possible_norm_law_firm import PossibleNormLawFirm
    globals()['AttorneyLawFirm'] = AttorneyLawFirm
    globals()['AttorneyType'] = AttorneyType
    globals()['Contact'] = Contact
    globals()['PartyAttorneyAssociations'] = PartyAttorneyAssociations
    globals()['PossibleNormAttorney'] = PossibleNormAttorney
    globals()['PossibleNormLawFirm'] = PossibleNormLawFirm


class Attorney(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('object',): {
            'max_length': 8,
            'min_length': 8,
        },
        ('attorney_id',): {
            'max_length': 18,
            'min_length': 18,
        },
        ('name',): {
            'max_length': 250,
            'min_length': 1,
        },
        ('name_prefix',): {
            'max_length': 10,
        },
        ('first_name',): {
            'max_length': 250,
        },
        ('middle_name',): {
            'max_length': 100,
        },
        ('last_name',): {
            'max_length': 100,
        },
        ('name_suffix',): {
            'max_length': 10,
        },
        ('attorney_law_firm_array',): {
            'max_items': 25,
        },
        ('bar_number',): {
            'max_length': 250,
        },
        ('source_attorney_type',): {
            'max_length': 250,
        },
        ('first_fetch_date',): {
            'max_length': 25,
            'min_length': 25,
        },
        ('last_fetch_date',): {
            'max_length': 25,
            'min_length': 25,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = True

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'object': (str,),  # noqa: E501
            'attorney_id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'name_prefix': (str, none_type,),  # noqa: E501
            'first_name': (str, none_type,),  # noqa: E501
            'middle_name': (str, none_type,),  # noqa: E501
            'last_name': (str, none_type,),  # noqa: E501
            'name_suffix': (str, none_type,),  # noqa: E501
            'contact': (Contact,),  # noqa: E501
            'attorney_law_firm_array': ([AttorneyLawFirm],),  # noqa: E501
            'bar_number': (str, none_type,),  # noqa: E501
            'attorney_type': (AttorneyType,),  # noqa: E501
            'source_attorney_type': (str,),  # noqa: E501
            'is_visible': (bool,),  # noqa: E501
            'first_fetch_date': (datetime,),  # noqa: E501
            'last_fetch_date': (datetime,),  # noqa: E501
            'party_attorney_associations': (PartyAttorneyAssociations,),  # noqa: E501
            'possible_norm_attorney_array': ([PossibleNormAttorney],),  # noqa: E501
            'possible_norm_law_firm_array': ([PossibleNormLawFirm],),  # noqa: E501
            'party_role_group_id_array': ([str],),  # noqa: E501
            'party_role_id_array': ([str],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'object': 'object',  # noqa: E501
        'attorney_id': 'attorneyId',  # noqa: E501
        'name': 'name',  # noqa: E501
        'name_prefix': 'namePrefix',  # noqa: E501
        'first_name': 'firstName',  # noqa: E501
        'middle_name': 'middleName',  # noqa: E501
        'last_name': 'lastName',  # noqa: E501
        'name_suffix': 'nameSuffix',  # noqa: E501
        'contact': 'contact',  # noqa: E501
        'attorney_law_firm_array': 'attorneyLawFirmArray',  # noqa: E501
        'bar_number': 'barNumber',  # noqa: E501
        'attorney_type': 'attorneyType',  # noqa: E501
        'source_attorney_type': 'sourceAttorneyType',  # noqa: E501
        'is_visible': 'isVisible',  # noqa: E501
        'first_fetch_date': 'firstFetchDate',  # noqa: E501
        'last_fetch_date': 'lastFetchDate',  # noqa: E501
        'party_attorney_associations': 'partyAttorneyAssociations',  # noqa: E501
        'possible_norm_attorney_array': 'possibleNormAttorneyArray',  # noqa: E501
        'possible_norm_law_firm_array': 'possibleNormLawFirmArray',  # noqa: E501
        'party_role_group_id_array': 'partyRoleGroupIdArray',  # noqa: E501
        'party_role_id_array': 'partyRoleIdArray',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, attorney_id, name, name_prefix, first_name, middle_name, last_name, name_suffix, contact, attorney_law_firm_array, bar_number, attorney_type, source_attorney_type, is_visible, first_fetch_date, last_fetch_date, party_attorney_associations, possible_norm_attorney_array, possible_norm_law_firm_array, party_role_group_id_array, party_role_id_array, *args, **kwargs):  # noqa: E501
        """Attorney - a model defined in OpenAPI

        Args:
            attorney_id (str): ID for the attorney in this case. This ID is unique within a case and NOT across cases. If the same attorney were to appear in another case this ID would be different.
            name (str): Name of the attorney as provided by Court.
            name_prefix (str, none_type):
            first_name (str, none_type): First name of the attorney. This is normalized by UniCourt.
            middle_name (str, none_type): Middle name of the attorney. This is normalized by UniCourt.
            last_name (str, none_type): Last name of the attorney. This is normalized by UniCourt.
            name_suffix (str, none_type):
            contact (Contact):
            attorney_law_firm_array ([AttorneyLawFirm]):
            bar_number (str, none_type): The bar enrollment number of an attorney.
            attorney_type (AttorneyType):
            source_attorney_type (str): Attorney Type as provided by Court.
            is_visible (bool): Signifies if the attorney as this attorney type is currently isVisible or not for the case.
            first_fetch_date (datetime): When was the attorney first fetched from the court site.
            last_fetch_date (datetime): When was the attorney last fetched from the court site.
            party_attorney_associations (PartyAttorneyAssociations):
            possible_norm_attorney_array ([PossibleNormAttorney]):
            possible_norm_law_firm_array ([PossibleNormLawFirm]): Possible Norm Lawfirm array for a Attorney.
            party_role_group_id_array ([str]): Party Role Group Id for a Attorney.
            party_role_id_array ([str]): Party Role Id for a Attorney.

        Keyword Args:
            object (str): Name of the object. defaults to "Attorney"  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        object = kwargs.get('object', "Attorney")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.object = object
        self.attorney_id = attorney_id
        self.name = name
        self.name_prefix = name_prefix
        self.first_name = first_name
        self.middle_name = middle_name
        self.last_name = last_name
        self.name_suffix = name_suffix
        self.contact = contact
        self.attorney_law_firm_array = attorney_law_firm_array
        self.bar_number = bar_number
        self.attorney_type = attorney_type
        self.source_attorney_type = source_attorney_type
        self.is_visible = is_visible
        self.first_fetch_date = first_fetch_date
        self.last_fetch_date = last_fetch_date
        self.party_attorney_associations = party_attorney_associations
        self.possible_norm_attorney_array = possible_norm_attorney_array
        self.possible_norm_law_firm_array = possible_norm_law_firm_array
        self.party_role_group_id_array = party_role_group_id_array
        self.party_role_id_array = party_role_id_array
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, attorney_id, name, name_prefix, first_name, middle_name, last_name, name_suffix, contact, attorney_law_firm_array, bar_number, attorney_type, source_attorney_type, is_visible, first_fetch_date, last_fetch_date, party_attorney_associations, possible_norm_attorney_array, possible_norm_law_firm_array, party_role_group_id_array, party_role_id_array, *args, **kwargs):  # noqa: E501
        """Attorney - a model defined in OpenAPI

        Args:
            attorney_id (str): ID for the attorney in this case. This ID is unique within a case and NOT across cases. If the same attorney were to appear in another case this ID would be different.
            name (str): Name of the attorney as provided by Court.
            name_prefix (str, none_type):
            first_name (str, none_type): First name of the attorney. This is normalized by UniCourt.
            middle_name (str, none_type): Middle name of the attorney. This is normalized by UniCourt.
            last_name (str, none_type): Last name of the attorney. This is normalized by UniCourt.
            name_suffix (str, none_type):
            contact (Contact):
            attorney_law_firm_array ([AttorneyLawFirm]):
            bar_number (str, none_type): The bar enrollment number of an attorney.
            attorney_type (AttorneyType):
            source_attorney_type (str): Attorney Type as provided by Court.
            is_visible (bool): Signifies if the attorney as this attorney type is currently isVisible or not for the case.
            first_fetch_date (datetime): When was the attorney first fetched from the court site.
            last_fetch_date (datetime): When was the attorney last fetched from the court site.
            party_attorney_associations (PartyAttorneyAssociations):
            possible_norm_attorney_array ([PossibleNormAttorney]):
            possible_norm_law_firm_array ([PossibleNormLawFirm]): Possible Norm Lawfirm array for a Attorney.
            party_role_group_id_array ([str]): Party Role Group Id for a Attorney.
            party_role_id_array ([str]): Party Role Id for a Attorney.

        Keyword Args:
            object (str): Name of the object. defaults to "Attorney"  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        object = kwargs.get('object', "Attorney")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.object = object
        self.attorney_id = attorney_id
        self.name = name
        self.name_prefix = name_prefix
        self.first_name = first_name
        self.middle_name = middle_name
        self.last_name = last_name
        self.name_suffix = name_suffix
        self.contact = contact
        self.attorney_law_firm_array = attorney_law_firm_array
        self.bar_number = bar_number
        self.attorney_type = attorney_type
        self.source_attorney_type = source_attorney_type
        self.is_visible = is_visible
        self.first_fetch_date = first_fetch_date
        self.last_fetch_date = last_fetch_date
        self.party_attorney_associations = party_attorney_associations
        self.possible_norm_attorney_array = possible_norm_attorney_array
        self.possible_norm_law_firm_array = possible_norm_law_firm_array
        self.party_role_group_id_array = party_role_group_id_array
        self.party_role_id_array = party_role_id_array
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
